<html>
<head>
<%-- image_frame.jsp
           ___________________________________________________
          |                                                   |
          | Image and Upload File Manager                     |
          |                                                   |
          | Copyright (C) 2000-2008 Revize LLC                |
          | All rights reserved.                              |
          |                                                   |
          |___________________________________________________|

           $Revision:   2.0  $
           $Date:   22 May 2008 02:44:50  $
           $Author:   nickm  $
////////////////////////////////////////////////////////////////////////////////
//                         Image Manager Change Log                           //
////////////////////////////////////////////////////////////////////////////////
---------------------
10-28-04 DO Changes
---------------------
Deleted 11-14-03 dead code

-Added support for developer supplied maxwidth and maxheight
-Reordered width/height and hspace/vspace to match properties display
-caller now correctly calculated using location.host (not location.domain)
-Image size constaints are displayed in preview frame when file is uploaded
-Image properties can be displayed by clicking on hidden link after the top
 heading in the right frame

---------------------
11-14-03 DO Changes
---------------------
Created RZ.im object for global objects.

Corrected numerous problems with absolute vs relative and multi-level locations.
The filelocation global javascript variable depreciated because it usage needed
review and correct throughout all the frames and pages.  It is now in the RZ.im
object.

Eliminated newfilelocation url parameter, java and javascript variable.

New function image_frame.jsp::findImageIdx() developed to find a match in the
frameset JavaScript arrays.  Must now use location and filename with extension
to determine reference file record. Added new location hidden field to
image_list.jsp form.

Eliminated function image_upload.html::RZfileExists(); Now using new
image_frame.jsp::findImageIdx() function.

Eliminated function image_upload.html::getFolderLocation(); Was only used by
depreciated function image_upload.html::RZfileExists().  RZ.im.currentFolder
global contains the upload file location.

Moved test for legacy location to image_list.jsp::browseFunction() from
image_list_functions.js::loadfile() function.

Remamed frameset JavaScript fileName[] array to imageFilename[]
Rename other FileName to filename (one of my rules - single word in dictionary)

Changed all alerts to call new message function in frameset to that displays
the message with an option to enter debug mode if trace or debug enabled.

Recoded image_list_functions.js::setup(), which highlights and retains the
initial selection and list states for all scenarios.

Eliminated image_list_functions.js::initialize() function since it was only
called from image_list_functions.js::setup() - code moved into setup()
Eliminated image_list_functions.js::blockNewFolder() function since is is only
one line of code and only called from once.

Deleted lots of dead code but some left for review by Mindfire.

Depreciated checkForRTEImage() function and associated global variables:
rootLocation, imagePathFileName, imageInfo and imageLoc.  Logic moved to new
initImageIdx() function.

-------------------------------------------------------------------
11-23-03 DO: testing remaining, known issues and future suggestions
-------------------------------------------------------------------
-Opening a folder should automatically select it
-Selecting a folder should automatically open it
-When "select none" button is clicked, the highlighted file on list should be cleared

-When file uploaded and use indicates it should replace existing file, display should
 indicate (new file)

-Uploading files should reset/delete prior upload selection

-Filenames with invalid label character's should get selected after upload

-Allow selection of files not in ref table (see: 'Not in Reference File Table' message
 in image_upload.html)
-RZ.im.isLegacyAbsoluteLocation not tested

-Listing Frame should be split into two frames so Browse always appears and only
 listing scrolls (scrollTo can then be eliminiated image_list.jsp::setup() function)

-When replacing RTE image, prompt to retain prior properties (except height & width)

-The following should be options: image properties, browse, create folder, delete file


******************************** not yet done *********************************
validate use of imageLocation in frames (it uses fileLocation)


Use findImageIdx to determine displayImageIdx; replaces the following functions:
	RZfileExists, checkIfExist, getCurrentIndex

Remove blanks from label

////////////////////////////////////////////////////////////////////////////////
//                         Image/File Manager Notes                           //
////////////////////////////////////////////////////////////////////////////////
This is the main frame set for the image and file upload support screens. It was
originally developed for uploading images, therefore the html page names
and internal variables use "image" in the names.

It is currently designed to run from ...www/revize/util and is called from the
snippet_helper_editform.js::RZselectFile() function.  The RZselectFile() function
is called in the following manners:
1) via the "change image" button placed directly on the edit form
2) via the "change image" button contained on the link manager screen
3) via the "image" icon contained in the RTE

For Revize 4.0, the following enhancements were added:
1) 	Image properties (height, width, vspace, hspace, border & align) stored in the
	reference file table (previously these properties were only available when
	called via the RTE)
2)	An image resizing capibility was added based on specified height and width
	(the original implementation did not retain proportions)
3)	Ability for Content Editor to select and create repository folders
	(the original implementation did not allow the developer to restrict create)


The following additional support files are required:
(this list of files has not been validated since the original release)
QUESTION: Is this list up-to-date?  If not, please update.
	/revize/util/image_error.jsp		Clone of: \client\error.jsp (used in xml Requests)
	/revize/util/image_list.jsp			Right frame which displays files in repository
	/revize/util/image_preview.jsp		Center Frame which displays the image
	/revize/util/image_return.jsp		Frame used for normal return from Xml requests
	/revize/util/image_upload.jsp		Top frame containing upload information
	/revize/util/cacheControl.jsp		Prevents image pages from being cached
	/revize/util/snippet_helper.js		JavaScript Developer library
	/revize/images/edit/noimage.gif		Placeholder image for edit form
	/revize/images/edit/cleardot.gif	Placeholder image for preview screen

How Image support works:
-----------------------
1. 	The "Change Image" button or RTE "Image" icon or calls the RZselectFile()
	function (contained in snipper_helper_editform.jsp).  Legacy snippets may
	call RZselectImage() which in turn calls RZselectFile().

2. 	RZselectFile() either opens this file in a new browser window OR gives
	focus to an image processing window left open from a prior request call
	and refreshes with current arguments

3.	This page (image_frame.jsp) is called by with the following arguments:
QUESTION: Is this list up-to-date?  If not, please update.
		-webSpaceName: WebSpace Name
		-fileType: Type of file: image or file
		-fileLocation: Location (path / sub-directory in Revize repository)
		-extensions: Permitted extensions for new uploads
		-displayElement: HTML Edit Form object used to display image
		-valueElement: HTML Edit Form field where uploaded filename is stored
		-fileId: current selected file Id (can be negative - which means no selection)

4.	The following frames are opened by this page:
QUESTION: Is this list up-to-date?  If not, please update.
		Left Bottom:	image_upload.html - used for uploading new images
		Left Top: 		image_blank.html (gets set to image_preview.html)
		Right: 			another frame set contianing the following frames:
						top frame: imageListFrame src="image_list.html"
						(the image_frame.jsp onLoad handler then loads
						image_list.jsp)
						bottom frame: deleteImageFrame src="image_delete.html"

5.	JSP code on this frame gets a complete list of all images currently stored
	in the repository and saves them in JavaScript arrays. These are referred to
	as frameset arrays in comments embedded throughout all the code pages. This
	enables checking for duplicate names and display of files in the right frame.
	The Id of the placeholder image (either noimage.gif or cleardot.gif) and
	all properties of the current image are saved for later use as JavaScript
	variables.  Most JavaScript variables are displayed in the Trace window.

Previewing Images
-----------------
	The image-preview.html frame initially displays the image scr passed via
	the url query string.  If no image src is specified, the blank image
	located at ...www/revize/images/edit/cleardot.gif is displayed.

	If the file is not an image, the filename is displayed.

	A dark blue border with a margin surrounds the image or filename.

	The file description is displayed under the image or filename.  Additional
	image properties appear when managing images.

	The image preview frame represents no image selection using the cleardot.gif
	from the /revize/images/edit/ directory.  The edit page html form page always
	represents no image selection with the "Your Image Here" graphic (noimage.gif)
	stored under the /revize/images/edit directory. We do not want rely on the
	repository containing these images for very old backward compatibility.

	Published pages simply display whatever image is associated with the Id
	stored in the underlaying record specified via an image <rz:fetch...> or
	<rz:link...> tag.  Id=0 should be the noimage.gif placeholder but it could
	change if noimage.gif is deleted and readded (the current Id will be used in
	that case).  If noimage.gif does not exist, the Id associated with cleardot.gif
	will be used.  If niether exists, an Id of -1 must be used which unfortunately
	will display a broken image on published pages.  The noimage.gif can be restored
	by exporting the entire webspace, deleting it and importing the export file.
	An alternative solution is to simply upload noimage.gif or cleardot.gif and
	go through the change image screen to use the newly assigned Id.


Selecting and Deleting Images
-----------------------------
	The image_list.html right frame displays a list of all images currently
	stored in the Revize repository at same location as specified for the
	editable image.	The list no longers contains noimage.gif or cleardot.gif files.
	The "select none" button must be used to specify noimage.

QUESTION: Is this list up-to-date?  If not, please update.
	When a new image is selected the main frameset is reloaded so all frames
	display the updated information.  This may be a bit costly but avoids
	dealing with browser (and Revize) quirks.

	The image currently in use can not be deleted.  A lengthly
	prompt explains the process to the content editor.


Uploading Images or Files
-------------------------
	The right frame contains a browser field for uploading new images.	Uploaded
	files are displayed in the mainFrame and added to the list in the list of files
	in the right frameset.  Uploaded images are not uploaded to the server until the
	"save" button in the left bottom frame is clicked.  Only one file is uploaded.

	The uploaded file MUST be in the browse field when save is clicked.  Browser
	security prevents JavaScript from setting this field.  It can only be set by
	the browser user via the browse button.  Since the browse field must be used,
	this implies the left frame form containing this field must be submitted when
	uploading a file.


Updating Calling Page (edit form, link manager and/or RTE
---------------------------------------------------------
	The image_frame.jsp::updateCaller() always passes the uploaded or selected file
	and associated parameters back to the calling page.

	If a servlet request must be made to update the reference file table, the file
	properties are stored in the opener window and updateCaller() is called after
	the servlet completes the request and reloads the image_frame.jsp page.  When
	image_frame.jsp is reloaded after a servlet request, the right frame file list
	is not rebuilt.


--------------------------------------------------------------------------------
--%>
<%@ page language="java" import="java.util.*" %>
<%@ page import="revize.data.*,revize.servlet.*,revize.store.*,revize.request.*,
	revize.resource.*, idetix.util.*, idetix.security.UserContext" %>
<%@ page import="java.io.*" %>
<%@ page import="revize.util.*" %>
<%@ include file = "cacheControl.jsp" %>
<%
String webSpaceName    = StringUtils.getParameter( request, "webSpaceName" );
String fileType        = StringUtils.getParameter( request, "fileType" );
String fileLocation    = StringUtils.getParameter( request, "fileLocation" ).replace('\\','/');
if (fileLocation.endsWith("/") && fileLocation.length() > 1)
	fileLocation = fileLocation.substring(0,fileLocation.length()-1);
while (fileLocation.indexOf("//") == 0)
	fileLocation = fileLocation.substring(1);
String filepath        = StringUtils.getParameter( request, "filepath" );
String extensions      = StringUtils.getParameter( request, "extensions" );
String displayElement  = StringUtils.getParameter( request, "displayElement" );
String valueElement    = StringUtils.getParameter( request, "valueElement" );
String fileId          = StringUtils.getParameter( request, "fileId" );
String caller          = StringUtils.getParameter( request, "caller" );
String brief 		   = StringUtils.getParameter( request, "brief" );
boolean isBrief  	   = brief.equals("true") ? true : false;
boolean isRTE          = StringUtils.getParameterBoolean(request, "rte");


DebugUtils.console( "image_frame", "Page loaded: image_frame.jsp"
                  + "\nfileLocation = " + fileLocation
                  + "\ncaller = " + caller);

//----- Create page title containing file location
String pageTitle = "Revize Image Manager";
if (fileType.equalsIgnoreCase("file")) pageTitle = "Revize File Manager";
// title tag written with JavaScript below.
session = request.getSession();
String tiny_mce = "tiny_mce." + (String)session.getAttribute("tinymce_version");
%>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"><%
if (isRTE) { %>
<script type="text/javascript" src="<%=tiny_mce%>/tiny_mce_popup.js"></script><%
} %>
<script type="text/javascript">
var RZ = new Object();
RZ.jsversion = 1.0;
</script>
<script type="text/javascript" language="JavaScript1.1">RZ.jsversion = 1.1;</script>
<script type="text/javascript" language="JavaScript1.2">RZ.jsversion = 1.2;</script>
<script type="text/javascript" src="snippet_helper.js"></script>
<script type="text/javascript" src="snippet_helper_fieldvalues.js"></script>
<script type="text/javascript" src="snippet_helper_validate.js"></script>
<script type="text/javascript">

//TODO: use setup_editform_header.jsp include
// 		(remove next line when above include used)
RZ.pagetype = 'edit page'	//used by RZalert();
//debugger	//image frame

/****************************************************************************
First part of code below executes before the onload handler and hopefully
before other frames are loaded since they need access to the image properties.
****************************************************************************/
<%
//TODO: should probably use standard Javascript header for below jsp:
ResourceReader revize = new ResourceService(webSpaceName);
UserContext userContext = (UserContext)session.getAttribute( SessionAccess.USER_CONTEXT_ATTRIBUTE );
if( userContext == null )
{
	userContext = new UserContext();
	userContext.setWebSpaceName( webSpaceName );
	session.putValue( SessionAccess.USER_CONTEXT_ATTRIBUTE, userContext );
}
else
{
	userContext.setWebSpaceName( webSpaceName );
}
%>
//////////////////////////////////////////////////////////////////////////////////////////
//                   ********** Global JavaScript variables **********                  //
//         All global variables should be stored in the RZ.im object define below       //
//           (this makes them easily recognizable as globals in the code)               //
//////////////////////////////////////////////////////////////////////////////////////////
RZ.webspace = "<%= webSpaceName %>"

RZ.im = new Object();
RZ.im.fileType = '<%=fileType%>'
RZ.im.repositoryLocation = '/revize/repository/'	//repository location with trailing slash

RZ.im.legacyImageIdx = -1							//index of legacy selection
RZ.im.legacyLocationFilename = ''					//src of current selection when
													//not in current location hierarchy
													//set by image_list.jsp::setup()
RZ.im.uploadedPathFilename = '<%=filepath%>'		//uploaded pathfilename
RZ.im.fileLocation = '<%=fileLocation%>' 			//same as fileLocationNoSlash except
													//leading slash if abs location
RZ.im.isBriefForm = '<%=isBrief%>';
<%
boolean isAbsoluteLocation = false;
if (fileLocation.startsWith("/"))
{
	isAbsoluteLocation = true;
	fileLocation = fileLocation.substring(1);
}
if (fileLocation.endsWith("/"))
	fileLocation = fileLocation.substring(0,fileLocation.length()-1);
%>
RZ.im.fileLocationNoSlash = '<%=fileLocation%>'		//backslashs always converted to slashs
													//trailing slash always removed even if
													//location was "/" (no leading webspace)
<% if (!fileLocation.equals("")) { %>
RZ.im.fileLocationDefault = '<%=fileLocation%>'		//top file list location
<% } else { %>
RZ.im.fileLocationDefault = '<%=webSpaceName%>'		//top file list location
<% } %>
RZ.im.isAbsoluteLocation = <%=isAbsoluteLocation%>	//true of false
RZ.im.isLegacyAbsoluteLocation = false				//used with legacy location

RZ.im.currentFolderId = ''							//e.g. y1demositeIII
RZ.im.currentFolder = RZ.im.fileLocationDefault		//upload folder
													//(webspace appended if no folder)

RZ.im.darkGray = '#a9a9a9'
RZ.im.transparent = 'transparent'
RZ.im.reload = false								//set true when reloading
													//(disable caller focus)

RZ.im.src = ''										//src from RTE (direct call via LM)
RZ.im.maxwidth = '';
RZ.im.maxheight = '';
RZ.im.maxbytes = '';
if (isLinkManagerCall())
{
	RZ.im.src = opener.RZ.imagePathFilename
	RZ.im.linkDisplayField = opener.RZ.linkDisplayField	//LM display field object
}
else if (haveExtendedImageProperties())					//RTE call
{
	var imageInfo = RZgetfileinfo(opener.RZ.rte.object.src)
	RZ.im.src = imageInfo.pathname + '/'
	          + imageInfo.filename + imageInfo.sep + imageInfo.extension

	var str = RZ.im.repositoryLocation + RZ.webspace + '/'
	if (RZ.im.src.indexOf(str) == 0)
		RZ.im.src = RZ.im.src.substring(str.length)
}

//----- If image object or rte
if (opener.RZ.image
&& opener.RZ.image.<%=valueElement%>.fileType == 'image' != -1)
{
	RZ.im.maxwidth = opener.RZ.image.<%=valueElement%>.maxwidth;
	RZ.im.maxheight = opener.RZ.image.<%=valueElement%>.maxheight;
	RZ.im.maxbytes = opener.RZ.image.<%=valueElement%>.maxbytes;
}

if (RZsubstring(RZ.im.src,0,1) == '/')
	RZ.im.isLegacyAbsoluteLocation = true

// set if new file uploaded
if ('<%=filepath%>')
	RZ.im.src = "<%=filepath%>"

if (RZsubstring(RZ.im.src,0,1) == '/')
	RZ.im.src = RZ.im.src.substring(1)

//----- Display page title with fieldname if not RTE
var pageTitle = '<%=pageTitle%>';
if (!isRTEcall()) pageTitle += ' (<%=valueElement%>)';
document.write('<title>',pageTitle,'</title>');

//////////////////////////////////////////////////////////////////////////////////////////
//           Below are legacy JavaScript variables not stored in RZ.im object           //
//////////////////////////////////////////////////////////////////////////////////////////

//----- Global JavaScript variables passed on url
//		TODO: most could be retrieved from RZ.image object
var webSpaceName   = "<%= webSpaceName %>"
var fileType       = "<%= fileType %>"
var extensions     = "<%= extensions %>"
var displayElement = "<%= displayElement %>"
var valueElement   = "<%= valueElement %>"
var fileId         = "<%= fileId %>"
if (fileId == '') fileId = -1

var caller         = "<%= caller %>"
if (caller == '')
	caller = opener.location.protocol
	       + opener.location.host
	       + opener.location.pathname
var isBrief   = <%=isBrief%>;

//----- Global JavaScript variables computed
var imageIdx = 0;
var imageId = new Array();
var imageName = new Array();
var imageLink = new Array();
var imageLocation = new Array();
var imageDescription = new Array();
var imageVersion = new Array();
var imageFilename = new Array();

var imageVertical = new Array();
var imageHorizontal = new Array();
var imageHeight = new Array();
var imageWidth = new Array();
var imageAlign = new Array();
var imageBorder = new Array();
var imageChanged = new Array();

var displayImageIdx = -1;
var noimageImageIdx = -1;
var cleardotImageIdx = -1;
var noneImageIdx = -1;
var newfileImageIdx = imageIdx
var newDesc = ''

var gbFileList = true;
var gbCurrentObj = null;
var gbPreviousObj = null;
var gbCurFolderObj = null;
var gbPreFolderObj = null;

<%
//----- Build a JavaScript Array of all Reference Files
//ReferenceFile [] referenceFiles = revize.readReferenceFiles();
ReferenceFile [] referenceFiles = revize.readReferenceFiles(fileLocation,StringUtils.toInt(fileId,-1));
for( int index = 0; index < referenceFiles.length; index++ )
{
	ReferenceFile r = referenceFiles[index];
	%>
	initImageIdx(imageIdx, "<%= r.getID() %>", "<%= r.getLabel() %>", "<%= r.getVersion() %>",
	             "<%= r.getLocation() %>", "<%= r.getFilename() %>",
	             "<%= StringUtils.replaceAll(revize.link( r ),"\\","/") %>",
	             "<%= r.getAlign() %>", "<%= r.getBorder() %>",
	             "<%= r.getVertical() %>", "<%= r.getHorizontal() %>",
	             "<%= r.getHeight() %>", "<%= r.getWidth() %>",
	             <%= StringUtils.convertStringForSource(r.getDescription()) %> );
    imageIdx++;
	<%
}
%>
//----- Last slot used for new files selected from local hard disk for upload.
newfileImageIdx = imageIdx
resetImageArrays(imageIdx)

//----- Set display index to current selection if no new image has been selected.
if((displayImageIdx == noneImageIdx && noneImageIdx >= 0)
|| (displayImageIdx == noimageImageIdx && noimageImageIdx >= 0)
|| (displayImageIdx == cleardotImageIdx && cleardotImageIdx >= 0))
	displayImageIdx = -1;

//----- Determine Id to use for no image or no file selection
//		(old edit snippets do not check for none.gif so don't use for images)
if (displayElement != "" || noneImageIdx < 0)
{
	noneImageIdx = noimageImageIdx;
	if (noneImageIdx == -1) noneImageIdx = cleardotImageIdx;
}

//----- Trace information
RZmessage = 'Current File Id: '    + fileId + '\n'
          + 'File Location: '      + RZ.im.fileLocation + '\n'
          + 'File Extensions: '    + extensions + '\n'
          + 'Preview File Index: ' + displayImageIdx + '\n'

if (displayImageIdx >= 0)
	RZmessage += 'Preview File Name (label): ' + imageName[displayImageIdx] + '\n'
			+ 'Preview Pathname (Link): ' + imageLink[displayImageIdx] + '\n'
			+ 'Preview Description: ' + imageDescription[displayImageIdx] + '\n'

if (noneImageIdx >= 0)
	RZmessage += 'Placeholder Image: ' + imageName[noneImageIdx] + '\n'

RZtrace("Select Image", RZmessage)


// DCO 07-39-2007 reactivated for update action
// DCO 06-23-2007 Not used when image reloaded as selected.
//----- If we have retured after an xml request to upload or update reference file,
//		check to see if this was an RTE call and if so, save properties and close
//		this window.  The RZ.image object is created by snippet_helper_editform.js
//		prior to calling this page.
//debugger	//after jsp setup
if(RZopenerAccess()
&& typeof opener.RZ != 'undefined'
&& typeof opener.RZ.image != 'undefined'
&& opener.RZ.image.complete)						//DCO 09-01-2007
//&& typeof opener.RZ.image.action != 'undefined'				  ''
//&& opener.RZ.image.action == 'update')		//DCO 07-29-2007  ''
// && opener.RZ.image.action != '')				//		 ''
{
	gbFileList = false;		//no need to create file list
	updateCaller();			//return to caller
	opener.RZ.image.complete = false;				//DCO 09-01-2007
}

/****************************************************************************
Remaining code defines javaScript functions used by Image Manager
****************************************************************************/

/*---------------------------------------------------------------------------
Following code is called by the frameset onLoad handler which runs after
all pages are loaded after their onload handlers run.
----------------------------------------------------------------------------*/
function setup()
{
	var msg = ''
	if (RZ.isnavigator && RZ.browserversion < 5)
		msg = 'Netscape version 6.2 or greater required'
	else if (RZ.jsversion < 1.1)
		msg = 'Browser must support JavaScript version 1.1 or greater'

	if (msg != '')
	{
		message( msg )
		return
	}

	//----- Save Link Manager description for new files
	if ( isLinkManagerCall('new') )
		newDesc = RZ.im.linkDisplayField.value

	//----- Determine src of selected image/file use by dirFileTree class.
	//		If is pass on url of list_image.jsp and must start with the
	//		webSpace name (without a leading slash).
	var src = ''
	if (isImageSelected())		//use src from ref file table if entry found
	{
		src = imageLink[displayImageIdx]
		src = src.substring(RZ.im.repositoryLocation.length)
	}
	else if (RZ.im.fileLocation == '/')
		src = RZ.im.src
	else if (RZ.im.src != '')	//otherwise use src passed from RTE or LM
		src = RZ.webspace + '/' + RZ.im.src

	//----- If file list required, load image_list.jsp with parameters
	RZ.message = ''
	RZmsgAdd('Link Manager Desc', newDesc)

	RZ.parameters = 'image_list.jsp'
	RZaddUrlParameter( 'webspace=' + webSpaceName )
	RZaddUrlParameter( 'fileType=' + fileType )
	RZaddUrlParameter( 'fileLocation=' + RZ.im.fileLocation )

	RZaddUrlParameter( 'src=' + src )
	RZtrace('image_frame::setup()', RZ.message)

	if (gbFileList) 	//if file list needed
	{
		imageListFrame.location = RZ.parameters
	}

	//----- Validate maxwidth and maxheight
	RZ.message = RZvalidatenumber('maximum image width', RZ.im.maxwidth, 'min=1')
	           + RZvalidatenumber('maximum image height', RZ.im.maxheight, 'min=1')
	           + RZvalidatenumber('maximum image height', RZ.im.maxbytes, 'min=0')
	if (RZ.message != '')
		RZalert(RZ.message)
}

/*---------------------------------------------------------------------------
Called when frameset unloads - gives focus to caller if still open.
----------------------------------------------------------------------------*/
function shutdown()
{
	if (RZ.im.reload) return
	if (typeof RZwinaccess == 'undefined') return
	if (RZwinaccess(opener)) opener.focus()
}
/*---------------------------------------------------------------------------
Called when existing image selected or after xml request
----------------------------------------------------------------------------*/
function updateCaller()
{
	if (!RZopenerAccess()) return false	//window closed if no access to opener

	//----- Make sure uploaded file in reference file table
	var isValidImage = isImageSelected();		//DCO 09-19-2007
	if (RZopenerAccess()						//		 ''
	&& typeof opener.RZ != 'undefined'			//		 ''
	&& typeof opener.RZ.image != 'undefined'	//		 ''
	&& opener.RZ.image.complete)				//		 ''
		isValidImage = true;					//		 ''
												//		 ''
	if (isValidImage)							//		 ''
	{											//		 ''
		var location = opener.RZ.image.location
		if (RZsubstring(location,0,1) == '/')
			location = location.substring(1)
		if (RZ.im.fileLocationNoSlash == '')
			location = RZ.webspace + '/' + location

		var filename = opener.RZ.image.filename
		displayImageIdx = findImageIdx( location, filename )
		if (displayImageIdx == -1)
		{
			message("Selected file not found in repository. Please retry.");
				//DCO 09-19-2007
				//window.close();
			return false;
		}
	}		//DCO 09-19-2007

	//----- If direct RTE call, then update source and return
	if ( isRTEcall() )
	{
		//----- If image is was highlighed on RTE call
		//		TODO: This test will not work if extended properties are ever
		//		available on non-RTE calls.
		if( haveExtendedImageProperties() )
		{
			//----- Set properties directly on the existing image object
			if ( !isImageSelected() )
			{
				deleteRteObject();
			}
			else if (opener.tinyMCE)
			{
				insertAction();
				opener.RZ.rte.object.src += '#';
			}
			else
			{
				opener.RZ.rte.object.src = opener.RZ.image.src;
				//if (opener.RZ.image.isAbsoluteLocation)
					opener.RZ.rte.object.rteaddedimage = 'absolute'
				//else
				//	opener.RZ.rte.object.rteaddedimage = 'relative'

				opener.RZ.rte.object.alt = opener.RZ.image.description

				if(opener.RZ.image.align != 'Default')
					opener.RZ.rte.object.align = opener.RZ.image.align;
				else
				{
					opener.RZ.rte.object.removeAttribute("align");
				}

				opener.RZ.rte.object.border = opener.RZ.image.border
				opener.RZ.rte.object.vspace = opener.RZ.image.vspace
				opener.RZ.rte.object.hspace = opener.RZ.image.hspace

				//if(opener.RZ.image.height != "")
					opener.RZ.rte.object.height = opener.RZ.image.height
				//if(opener.RZ.image.width != "")
					opener.RZ.rte.object.width = opener.RZ.image.width
				if(opener.RZ.image.height == "")
					opener.RZ.rte.object.removeAttribute("height")
				if(opener.RZ.image.width == "")
					opener.RZ.rte.object.removeAttribute("width")

				//--RTE--method added to edit image on netscape

				if(!opener.RZIEonWin)
					opener.RZinsertRteEditImage_cp();
			}
		}
		//----- No image was highlighted on RTE call and an image is now selected
		//		(place selected image on RTE)
		else if ( isImageSelected() )
		{
			if (opener.tinyMCE)
			{
				insertAction();
			}
			else
			{
				var attr = "";

				if(opener.RZ.image.align != '')
					attr += ' align ="' + opener.RZ.image.align + '"';
				if(opener.RZ.image.border != '')
					attr += ' border="' + opener.RZ.image.border + '"';
				if(opener.RZ.image.hspace != '')
					attr += ' hspace="' + opener.RZ.image.hspace + '"';
				if(opener.RZ.image.vspace != '')
					attr += ' vspace="' + opener.RZ.image.vspace + '"';
				if(opener.RZ.image.alt != '')
					attr += ' alt="' + opener.RZ.image.alt + '"';
				attr += ' '
				RZtrace("Image Attributes", attr );

				opener.RZaddReferenceFileId( imageId[displayImageIdx] )

				var type = 'relative';
				if (opener.RZ.image.isAbsoluteLocation)
					type = 'absolute';

				// ***** PLEASE DON'T CHANGE THE SPACINGS OR ORDER OF IMG ATTRIBUTES ******
				//--RTE--image manager
				if(!document.all)
				{
					if(opener.RZ.image.src.indexOf("//") == -1)
					{
						var indexOfTwoSlashes =	(document.location.href).indexOf("//");
						var tempSubStr = (document.location.href).substring(indexOfTwoSlashes + 2);
						var indexOfThirdSlash = tempSubStr.indexOf("/",0);
						var hrefStr =(document.location.href).substring(0,indexOfThirdSlash + 2 + indexOfTwoSlashes);
						opener.RZ.image.src = hrefStr + opener.RZ.image.src;
					}
				}
				window.opener.RZinsertRteImage('<img src="' + opener.RZ.image.src
											  + '" rteaddedimage="' + type + '"'
											  + attr
											  + ' />');
			}
		}
	}
	//----- File or Image object update (including link manager via RTE)
	//		Do not need to worry about nothing selected for RTE because Link
	//		manager requires a selection even if it just the none placeholder.
	else
	{
		var newImageId = -1
		if (noneImageIdx != -1)
			newImageId = imageId[noneImageIdx]
		var newImageLink = '/revize/images/edit/noimage.gif'
		var newImageDesc = ''
		var newImageFilename = '--- None ---'
		var newImageHieght = '';
		var newImageWidth = '';
		var newImageBorder = '';

		if ( isImageSelected() )
		{
			newImageId = imageId[displayImageIdx]
			newImageLink = imageLink[displayImageIdx]
			newImageDesc = imageDescription[displayImageIdx]
			newImageFilename = imageFilename[displayImageIdx]
			newImageHieght = imageHeight[displayImageIdx]
			newImageWidth = imageWidth[displayImageIdx]
			newImageBorder = imageBorder[displayImageIdx]
		}

		opener.document.XMLForm[valueElement].value = newImageId;
		if (fileType == 'image')
		{
			if (typeof opener.document.images[displayElement] != 'undefined')
			{
				opener.document.images[displayElement].src = newImageLink;
				opener.document.images[displayElement].alt = newImageDesc;

			/*	11-14-03 DO: not honored on templates, so do not set on edit form for now
				//QUESTION: Will this work on Netscape?
				if(newImageHieght != '') opener.document.images[displayElement].style.height = newImageHieght;
				if(newImageWidth != '')  opener.document.images[displayElement].style.width = newImageWidth;
				if(newImageBorder != '') opener.document.images[displayElement].border = newImageBorder;
			*/
			}
		}else
		{
			if (typeof opener.document.XMLForm[displayElement] != 'undefined')
				opener.document.XMLForm[displayElement].value = newImageFilename;
		}

		//----- Update link manager location for RTE calls
		if ( isLinkManagerCall() && displayImageIdx != -1 )
		{
			var linkPath = imageLocation[displayImageIdx].split('\\').join('/')
			if (linkPath != '' && RZright(linkPath,1) != '/')	//add trailing slash
				linkPath += '/'
			var imagePathFilename = linkPath + imageFilename[displayImageIdx];

			//----- Set src in link manager opener RZ object for updating RTE link
			opener.RZ.imagePathFilename = imagePathFilename
		}
	}
	window.opener.focus();
	window.close();
	return;
}
/*------------------------------------------------------------------------------
Clear / reset all properties for upload option
------------------------------------------------------------------------------*/
function resetImageArrays(imageIdx)
{
	imageId[imageIdx] = '-1';
	imageName[imageIdx] = '';
	imageLink[imageIdx] = '';
	imageLocation[imageIdx] = '';
	imageDescription[imageIdx] = '';
	imageVersion[imageIdx] = 0;
	imageFilename[imageIdx]= '';

	imageVertical[imageIdx] = '';
	imageHorizontal[imageIdx] = '';
	imageHeight[imageIdx] = '';
	imageWidth[imageIdx] = '';
	imageAlign[imageIdx] = '';
	imageBorder[imageIdx] = '';

    imageChanged[imageIdx]= false;
}

/*------------------------------------------------------------------------------
Set this element of image arrays; check for special files (none,noimage,cleardot)
and determine if this file is the current selection.
------------------------------------------------------------------------------*/
function initImageIdx(
	imageIdx, id, label, version,
	location, filename,
	link,
	align, border,
	vspace, hspace,
	height, width,
	description)
{
    //----- Save parameters in image arrays
    if (location.indexOf('//') == 0) location = location.substring(1);
    imageId[imageIdx] = id
    imageName[imageIdx] = label
    imageVersion[imageIdx] = version
    imageLocation[imageIdx] = location
    imageFilename[imageIdx]= filename
    imageLink[imageIdx] = link

    imageAlign[imageIdx] = align
    if (imageAlign[imageIdx] == null || imageAlign[imageIdx] == "")
    	imageAlign[imageIdx] = "Default"
    imageBorder[imageIdx] = border

    imageVertical[imageIdx] = vspace
    imageHorizontal[imageIdx] = hspace

    imageHeight[imageIdx] = height
    imageWidth[imageIdx] = width

    imageDescription[imageIdx] = description
    imageChanged[imageIdx]= false


	//---- Test for special files
	var labelTest = label.toLowerCase()
    if( labelTest == 'none' )
    {
		noneImageIdx = imageIdx
		return
	}
	else if( labelTest == 'noimage' )
	{
		noimageImageIdx = imageIdx
		return
	}
	else if( labelTest == 'cleardot' )
	{
		cleardotImageIdx = imageIdx
		return
	}

	//----- Check if this file is the current selection
	//		The fileId never passed by a direct RTE call.
	//		If RTE calls LM which in turn calls IM, the fileId will not be known
	//		(unless the LM calls the IM after the IM returns a selection before
	//		the LM returns to the RTE). The IM sets the fileId when a selection
	//		is returned to the LM which is valid untill the LM is reloaded.
    if (fileId >= 0)
    {
    	if(imageId[imageIdx] == fileId) displayImageIdx = imageIdx;
	}
    else if (RZ.im.src != '')
    {
		var existingFile = RZ.im.repositoryLocation 						//DCO 07-30-2007
		if (RZ.im.isAbsoluteLocation)										//		 ''
			existingFile += RZ.webspace + '/';								//		 ''
		existingFile += RZ.im.src;											//		 ''

		//var existingFile = RZ.im.repositoryLocation + RZ.webspace + '/'	//		 ''
		//                 + RZ.im.src										//		 ''

		if (link.indexOf(existingFile) == 0) displayImageIdx = imageIdx;
	}
}
/*------------------------------------------------------------------------------
Display message indicating nothing is happening
//TODO: If link highlighted link on RTE, delete it.
------------------------------------------------------------------------------*/
function deleteRteObject()
{
	alert('No changes saved because no image was selected.\n\n'
		 +'To delete images from Rich Text Editor, simply select\n'
		 +'the image in the editor and then press the delete key.')
}
/*------------------------------------------------------------------------------
Find index in frameset JavaScript arrays of location/filename (with extension)
location	server repository location determined by highlighted selection
			at time of upload.  It should never be blank because when no location
			is specified the location defaults to the webspace name.
filename	filename including extension of uploaded file
------------------------------------------------------------------------------*/
function findImageIdx(location,filename)
{
	//----- Remove leading and trailing slashes
	location = RZreplaceAll( location, '\\', '/' )
	if (location.indexOf('/') == 0)
		location = location.substring(1);
	if (RZright(location,1) == '/')
		location = location.substring(0,location.length-1)

	//----- Combine location and filename (location is never blank)
	var searchFilename = (location + '/' + filename).toLowerCase()
	if (searchFilename.substring(0,1) == '/')
		searchFilename = searchFilename.substring(1)

	//----- Remove leading webspace if it exists
	searchFilename = stripLeadingWebSpace(searchFilename)

	for (var i=0; i<imageName.length; i++)
	{
		if (imageName[i] == '') continue;
		var arrayFilename = imageFilename[i]
		if (imageLocation[i] != '' && imageLocation[i] != '/')
			arrayFilename = imageLocation[i] + '/' + imageFilename[i]
		arrayFilename = arrayFilename.toLowerCase()

		if (arrayFilename.indexOf('/') == 0)
			arrayFilename = arrayFilename.substring(1);

		if (searchFilename == arrayFilename)
			return i;
	}
	return -1;
}
/*------------------------------------------------------------------------------
Strip leading webspace folder name when no current location specified
or the image location/filename matches the legacyLocationFilename

Used by findImageIdx() because location could start with webspace name and
webspace name is not stored in the imageLocation[] array
------------------------------------------------------------------------------*/
function stripLeadingWebSpace(searchFilename)
{
	//----- If searchFilename is expected to start with webSpace name
	if(RZ.im.fileLocationNoSlash == ''
	|| searchFilename.toLowerCase() == RZ.im.legacyLocationFilename.toLowerCase() )
	{
		searchFilename = searchFilename.substring(RZ.webspace.length+1)
	}
	return searchFilename
}
/*---------------------------------------------------------------------------
Called by image_blank or image_list to preview an image in the mainFrame
The frame is refreshed so Netscape will reset the image hieght and width.
----------------------------------------------------------------------------*/
function previewImage()
{
	var src = '';
	if (isImageSelected())
		src = imageLink[displayImageIdx]

	mainFrame.location.href = 'image_preview.html?' + escape(src)
}
/*------------------------------------------------------------------------------
Check for valid extensions
------------------------------------------------------------------------------*/
function checkFileExtension(imagePath)
{
	var fileInfo = RZgetFileInfo(imagePath);
	if (fileType == 'image')
	{
		if (fileInfo.extension.toLowerCase() != 'jpg'
		&& fileInfo.extension.toLowerCase() != 'jpeg'
		&& fileInfo.extension.toLowerCase() != 'png'
		&& fileInfo.extension.toLowerCase() != 'gif'
		&& fileInfo.extension.toLowerCase() != 'eps')
		{
			message('File selected must be image file \n\n(e.g. jpg, jpeg or gif)')
			return null;
		}
	}
	return fileInfo
}
/*---------------------------------------------------------------------------
Determine if link manager call
----------------------------------------------------------------------------*/
function isLinkManagerCall(mode)
{
	if ( !RZwinaccess(opener) ) return false

	if(typeof opener.RZ != 'undefined'
	&& typeof opener.RZ.linkDisplayField != 'undefined')
	{
		if (typeof mode == 'undefined')
			return true
		if (mode != 'new' || opener.linkType == '')
			return true;
	}
	return false;
}
/*---------------------------------------------------------------------------
Determine if RTE call
----------------------------------------------------------------------------*/
function isRTEcall()
{
	if ( !RZwinaccess(window.opener) ) return false

	if(RZ.im.fileType != 'image'
	|| typeof window.opener.RZ.image == 'undefined'
	|| typeof window.opener.RZ.image.isRTE == 'undefined'
	|| window.opener.RZ.image.isRTE == false)
		return false
	else
		return true
}
/*------------------------------------------------------------------------------
Is an image selected other than none
------------------------------------------------------------------------------*/
function isImageSelected()
{
	if (displayImageIdx == -1
	|| displayImageIdx == noneImageIdx)
		return false

	if (displayImageIdx == newfileImageIdx
	&& imageName[newfileImageIdx] == '')
		return false

	return true
}
/*---------------------------------------------------------------------------
Build string to display image manager properties
----------------------------------------------------------------------------*/
function imageManagerProperties()
{
	var imagename = parent.valueElement
	var msg = 'Image Manager properties (field=' + imagename + ') :\n'
	var value = ''
	for (var i in parent.opener.RZ.image[imagename])
	{
		msg += '    ' + i + '  =  '
		value = parent.opener.RZ.image[imagename][i]
		if (i == 'set')
			value = value.split(',').join(',\n                ')
		else if (i.indexOf('url') != -1)
		{
			value = value.split('?').join('\n                    ?')
			value = value.split('&').join('\n                    &')
		}
		msg += value + '\n'
	}
	return msg;
}
/*---------------------------------------------------------------------------
Determine if we have extended image properties (RZ.rte.object not "")
Note: careful using this because it assume extended image properties are
      only available on RTE calls.  If logic is changed review all calls.
----------------------------------------------------------------------------*/
function haveExtendedImageProperties()
{
	var haveProperty = true
	if(isRTEcall() == false
	|| typeof window.opener.RZ.rte.object == "undefined"
	|| window.opener.RZ.rte.object == null
	|| window.opener.RZ.rte.object == "")
		haveProperty = false
	//RZtrace('Extended Image Properties: ' + haveProperty,'')
	return haveProperty
}
/*---------------------------------------------------------------------------
If there is no longer any access to opener, display prompt and close frameset
----------------------------------------------------------------------------*/
function RZopenerAccess()
{
	if (!RZwinaccess(opener))
	{
		message( 'The calling window is not accessible to save your new selection.\n'
			   + '(refreshing or closing the calling window are possible causes)\n\n'
			   + 'Retry your change and give system time to respond.' )
		//DCO 09-19-2007
		//window.close();
		return false;
	}
	var url= opener.location.protocol
	       + opener.location.host
	       + opener.location.pathname

	if (url != caller)
	{
		message( 'The calling window is no longer open to save your new selection.\n'
			   + 'Retry your change and give system time to respond.' )
		//DCO 09-19-2007
		//window.close();
		return false
	}

	return true
}

/*---------------------------------------------------------------------------
Build URL for upload, update or delete request sent to TranslatorServlet
If optional imageIdx argument is supplied, include current file id and label
----------------------------------------------------------------------------*/
function buildXmlRequest(action,imageIdx)
{
	RZ.message = ''
	RZ.parameters = '/revize/HTTPTranslatorServlet'
	RZaddUrlParameter( 'forward=util/image_return.jsp' )
	RZaddUrlParameter( 'error=util/image_error.jsp' )
	RZaddUrlParameter( 'webspace=' + webSpaceName )
	RZaddUrlParameter( 'action='   + action )
	RZaddUrlParameter( 'resourcetype=referencefile' )
	if (location.search.toLowerCase().indexOf('&rte=tinymce') != -1)
		RZaddUrlParameter( 'rte=tinymce' )

	if (typeof imageIdx != 'undefined')
	{

		//RZaddUrlParameter( 'id='       + imageId[imageIdx] )
		if(imageIdx == -999)
		{
			RZaddUrlParameter( 'id=-999')
			//RZaddUrlParameter( 'label='    + gbCurFolderObj.id.substring(2+parent.webSpaceName.length+1)+"hellomesusua")
			RZaddUrlParameter( 'label='    + gbCurFolderObj.id.substring(2)+"hellomesusua")
		}
		else
		{
		RZaddUrlParameter( 'id='       + imageId[imageIdx] )
		RZaddUrlParameter( 'label='    + imageName[imageIdx] )
	}
	}

	//Mindfire: added parameters for height and width
	//TODO QUESTION: Isn't this info saved elsewhere?
	RZaddUrlParameter( 'height='	+ topFrame.extendedForm.height.value);
	RZaddUrlParameter( 'width='	    + topFrame.extendedForm.width.value);
	RZaddUrlParameter( 'vspace='	+ topFrame.extendedForm.vspace.value);
	RZaddUrlParameter( 'hspace='	+ topFrame.extendedForm.hspace.value);
	RZaddUrlParameter( 'align='	    + RZgetfieldvalue(topFrame.extendedForm.align));
	RZaddUrlParameter( 'border='	+ topFrame.extendedForm.border.value);

	//following for image_frame reload by image_return.jsp
	RZaddUrlParameter( 'webSpaceName='   + webSpaceName )
	RZaddUrlParameter( 'fileType='       + fileType )
	RZaddUrlParameter( 'fileId='         + fileId )
	RZaddUrlParameter( 'fileLocation='   + RZ.im.fileLocation )
	RZaddUrlParameter( 'extensions='     + extensions )
	RZaddUrlParameter( 'valueElement='   + valueElement )
	RZaddUrlParameter( 'displayElement=' + displayElement )
	RZaddUrlParameter( 'caller='         + caller )

	RZtrace( "XML Request", RZ.message )

	return RZ.parameters
}
/*---------------------------------------------------------------------------
Display alert if not debug mode; if debug display as confirm with option to
enter debugger.
----------------------------------------------------------------------------*/
function message(str)
{
	//DCO 09-01-2007\\
	if (RZright(str,1) == '.')
		str = str.substring(0,str.length-1);

	var note = topFrame.document.getElementById('expandedNote')
	if (topFrame.inputForm == topFrame.document.descForm)
		note = topFrame.document.getElementById('desconlyNote')
	note.innerHTML = '<font color="red">' + str.replace(/\n/,'<br>') + '</font>'
	//note.innerHTML = '<font color="red">' + str + '</font>'

	if (parent.RZ.debug || parent.RZ.trace)
		if ( confirm(str + '\n\nEnter Debug Mode?') )
			RZstartDebugger()
	//DCO 09-01-2007//

	/* DCO 09-01-2007
	if (parent.RZ.debug == false && parent.RZ.trace == false)
		alert(str)

	else if ( confirm(str + '\n\nEnter Debug Mode?') )
	*/
}

/*---------------------------------------------------------------------------
----------------------------------------------------------------------------*/
function uploadForm()
{<%
	if(isBrief)
    { %>
    return topFrame.document.briefForm;<%
	}
	else
    { %>
    return imageListFrame.document.form;<%
    } %>
}

/*---------------------------------------------------------------------------
Insert image into tinyMCE. Modified copy of function
of same name in advImage plugin (v3.0) (changes noted).
TODO: this code should be moved to revize_image_manager/editor_plugin.js
----------------------------------------------------------------------------*/
function insertAction()
{
    var ed = tinyMCEPopup.editor, v, args = {}, el;

    tinyMCEPopup.restoreSelection();

    // Fixes crash in Safari
    if (tinymce.isWebKit)
        ed.getWin().focus();

	args = {
		vspace : opener.RZ.image.vspace,
		hspace : opener.RZ.image.hspace,
		border : opener.RZ.image.border,
		align : opener.RZ.image.align
	};

    tinymce.extend(args, {
        src : opener.RZ.image.src,  // NJM
        width : opener.RZ.image.width,
        height : opener.RZ.image.height,
        alt : opener.RZ.image.alt,
        title : opener.RZ.image.description,
        'class' : '',
        style : '',
        id : '',
        dir : '',
        lang : '',
        usemap : '',
        longdesc : ''
    });

    args.onmouseover = args.onmouseout = '';

    /* TODO: could be added functionality later
    if (onmousemove) {
        if (onmouseoversrc)
            args.onmouseover = "this.src='" + onmouseoversrc + "';";

        if (onmouseoutsrc)
            args.onmouseout = "this.src='" + onmouseoutsrc + "';";
			}
	*/

    el = ed.selection.getNode();

    if (el && el.nodeName == 'IMG')
        ed.dom.setAttribs(el, args);
    else
	{
        ed.execCommand('mceInsertContent', false, '<img id="__mce_tmp" />', {skip_undo : 1});
        ed.dom.setAttribs('__mce_tmp', args);
        ed.dom.setAttrib('__mce_tmp', 'id', '');
        ed.undoManager.add();
	}
	//DCO 06-29-2009 uses normal window close after return
	//tinyMCEPopup.close();

}
/*------------------------------------------------------------------------------
***** END OF JAVASCRIPT FUNCTIONS *****
------------------------------------------------------------------------------*/
</script>
</head>
<% if(isBrief) {%>
<frameset rows="*" cols="100%,*" framespacing="0" frameborder="no" border="0"
onLoad="setup()" onUnload="shutdown()">
<% } else { %>
<frameset rows="*" cols="*,255" framespacing="0" frameborder="no" border="0"
onLoad="setup();" onUnload="shutdown()">
<% } %>
	<frameset rows="416,135" cols="*" framespacing="0" frameborder="no" border="0">
		<frame src="image_blank.html" name="mainFrame" frameborder="no" marginwidth="5" marginheight="0" hscrolling="yes" />
		<frame src="image_upload.html" name="topFrame" frameborder="no" scrolling="no" marginwidth="2" marginheight="0" />
	</frameset>
	<frameset rows="*,50" cols="*" framespacing="0" frameborder="yes" border="2">
		<frame name="imageListFrame" src="image_list.html" marginwidth="5" marginheight="0" />
		<frame name="deleteImageFrame"  noresize='noresize' src="image_delete.html" frameborder="yes" marginwidth="5" marginheight="0" />
	</frameset>
</frameset>

<noframes>
<body>
<h1>Frames Required</h1>
</body>
</noframes>
</html>
