<%@ include file="/util/setup_editlist_header.jsp" %>
<html>
<head>
<title>xml</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<%@	page import="java.util.*,revize.data.*, revize.servlet.*,
	revize.db.*,revize.store.*,
	idetix.util.StringUtils, revize.RevizeConstants, revize.*, java.net.*" %>
<%
/* * * * * * * * * * * * * LINK MANAGER PROCESSING * * * * * * * * * * * * *

This page is called from mainFrame.linkCreateLinkRecord() - step 2 with mode:
'linkrecord' or 'templaterecord'
(mode: 'url' if checking for template instance)

Its purpose is to create a record and return the recordid.

Depending on the scenario, it may be called multiple times.

A new link and/or dependent template module record will be created.

---------------------------------------------------------------------------*/
String mode = StringUtils.getParameter(request,"mode");

// these parameters only set when called from mainFrame.linkCreateLinkRecord
String webspace = StringUtils.getParameter(request,"webspace");
String template = StringUtils.getParameter(request,"template");
String module = StringUtils.getParameter(request,"module");
String linkid = StringUtils.getParameter(request,"linkid");
String filename = StringUtils.getParameter(request,"filename");
String set = StringUtils.getParameter(request,"set");
String rte = StringUtils.getParameter(request,"rte");
// these parameters only set after this calls itself
String url = StringUtils.getParameter(request,"url");
url = StringUtils.replaceAll(url,"\\","\\\\");


String overwrite_file= StringUtils.getParameter(request,"overwrite_file");

String absoluteurl = StringUtils.getParameter(request,"absoluteurl");

absoluteurl = StringUtils.replaceAll(absoluteurl,"\\","\\\\");




String reloadurl = "linkmanager_xml.jsp?"+"mode="+mode+"&webspace="+webspace+"&template="+template+"&module="+module+"&linkid="+linkid;
reloadurl=reloadurl+"&filename="+filename+"&set="+set+"&rte="+rte;
revize.publish.TemplateInstance ti = null;
DataStore ds = DataStoreFactory.createDefault(webspace);
Module m = null;
String templatename = "";
String linkfilename="";
int recordid = -1;
String tosectionid = "";
String revizeServerProtocol = "";
String revizeServerName = "";
String revizeServerPort= "";
String revizeServer = "";
boolean isRevizeServerUrl = false;
boolean isValidUrl = true;
boolean RevizePage = true;
boolean RevizeChannelUrl = false;
boolean isPoundInUrl = false;
String relativePath = "";
boolean fileExists = false;
String other = "";
String hashStr = "";
String my_revizechannelurl="";
revize.db.TemplateInstanceDB tiDB = new revize.db.TemplateInstanceDB(webspace);
if (filename.indexOf("/") == 0) filename = filename.substring(1);


//----- Create a link or dependent module record
if (mode.indexOf("record") != -1)
{
	LinkManager lm = new LinkManager(webspace);
	int linkidInt = Integer.valueOf(linkid).intValue();

	//If Other template instances using this file
	if(module.equals("links"))
	{

		fileExists = lm.fileNameExistsInLinksModule(module,filename);
	}
	else
	{

		fileExists = tiDB.fileNameExists(filename);
	}

	//----- Create new dependent module record; return linkid and url.
	if (!fileExists && (overwrite_file.equals("yes")
	|| !lm.fileNameExists(template,filename,linkidInt)))
	{
		lm.createDependentRecord( template, module, filename, linkidInt );
		linkid = new Integer(lm.getRecordId()).toString();
		url = lm.getUrl();
	}
	else if(!fileExists && !lm.fileNameExists( template, filename,
	                    Integer.valueOf(linkid).intValue() ))
	{
			lm.createDependentRecord( template, module, filename,
			                    Integer.valueOf(linkid).intValue());
			linkid = new Integer(lm.getRecordId()).toString();
			url = lm.getUrl();
	}

	else
	{
		linkid = "-1";
	}
}
else if (mode.equals("url") || mode.equals("urltemplate"))
{

	String otrUrl = "";
	String chkUrl = url;
	int pipe_idx = chkUrl.indexOf(" ");

	/*
	if (pipe_idx != -1){

		otrUrl = chkUrl.substring(pipe_idx,chkUrl.length());
		if(otrUrl.length()>0)
		other  = otrUrl.substring(1,otrUrl.length());

		chkUrl = chkUrl.substring(0,pipe_idx);
	}
	*/

	String url1= chkUrl;

	//String url1= url;
	int pound_idx = url1.indexOf("#");
	if(url1.toLowerCase().indexOf("javascript:")==0
	|| url1.toLowerCase().indexOf("mailto:") ==0
	|| pound_idx == 0)
	{
	    //linkfilename = url1;
	    RevizePage = false;

	    absoluteurl=url1;

	}
	else
	{
		String sqlUrl = url1;
		if (pound_idx > 0 )
		{
			hashStr = url1.substring(pound_idx,url1.length());
			url1 = url1.substring(0,pound_idx);
			isPoundInUrl = true;
			//System.out.println("is pound URL true");
		}
		// DJO - 2-22-18: escape single quotes. Not needed if we parameterize query
		sqlUrl = url1.replaceAll("'","''");
		// Check if relative url is entered
		ti = tiDB.getTemplateInstanceForUrl(sqlUrl);

		//Iterate over all the channels. Check if absolute url is entered
		if(ti == null)
		{
			List channels = ds.readChannels();
			Iterator itr = channels.iterator();
			while(itr.hasNext())
			{
				Channel c = (Channel)itr.next();
				String baseurl = c.getBaseUrl();
				if(url.length() <= baseurl.length()) continue;

				String desc = c.getDescription();
				if(desc.equalsIgnoreCase("Revize Server Output Channel"))
					my_revizechannelurl=baseurl;
				if(baseurl != null && !baseurl.equals(""))
				{
					int idx = url.indexOf(baseurl);
					if (idx == 0)
					{
						if(baseurl.endsWith("/"))
							relativePath = url1.substring(baseurl.length());
						else
							relativePath = url1.substring(baseurl.length()+1);
						ti=tiDB.getTemplateInstanceForUrl(relativePath);
						if(ti != null)
						{
							System.out.println("TemplateInstance:" + ti.getTemplateId() + " mid:" + ti.getLinkedModuleId() + " rid:" + ti.getLinkedRecordId() );

							tosectionid = "";
							m = ds.readModule(ti.getLinkedModuleId());
							templatename = ds.readTemplate(ti.getTemplateId()).getLabel();
							recordid = ti.getLinkedRecordId();
							url ="";

							if (m != null)
							{
								String where = m.getLabel() + "._recordid=" + recordid;
								String options = "report,recordid=" + recordid;
								if (rz.isvalidfield(m.getLabel(),"linktosectionid"))
									tosectionid = rz.fetch(m.getLabel(),"linktosectionid",options);//,where);
							}
							linkfilename = relativePath;
							break;
						}
					}
				}
			}
		}
		else
		{
			linkfilename= url1;
			templatename = ds.readTemplate(ti.getTemplateId()).getLabel();
			recordid = ti.getLinkedRecordId();
		}

		if(!isPoundInUrl)
		{


			//System.out.println("TemplateInstance:" + ti.getTemplateId() + " mid:" + ti.getLinkedModuleId() + " rid:" + ti.getLinkedRecordId() );
			if(ti != null)
			{

				tosectionid = "";
				m = ds.readModule(ti.getLinkedModuleId());
				templatename = ds.readTemplate(ti.getTemplateId()).getLabel();
				recordid = ti.getLinkedRecordId();
				url ="";

				if (m != null)
				{
					String where = m.getLabel() + "._recordid=" + recordid;
					String options = "report,recordid=" + recordid;
					if (rz.isvalidfield(m.getLabel(),"linktosectionid"))
						tosectionid = rz.fetch(m.getLabel(),"linktosectionid",options);//,where);
				}
			}
			else
			{
				String new_absoluteurl = absoluteurl;
				try
				{
					URL thisurl = new URL(new_absoluteurl);
					URLConnection urlConn = thisurl.openConnection();
					urlConn.connect();
					// below line needed to drop connections
					java.io.InputStream stream = urlConn.getInputStream();
				}
				catch(Exception e)
				{
					isValidUrl = false;
				}
				RevizePage = false;
				boolean isRelativeUrl = !url.equals(absoluteurl) && url.indexOf("http") != 0 && url.indexOf("//") != 0;
				boolean isPluginContext = absoluteurl.indexOf("revize/plugins/menus") != -1;
				if( isRelativeUrl || isPluginContext )
				{
					absoluteurl = url;
					if( absoluteurl.indexOf("./..") != 0 ) {
						isRevizeServerUrl = true;
					}
				}
				else
				{
					revizeServerProtocol = System.getProperty(RevizeProperties.WEB_SERVER_PROTOCOL);
					revizeServerName = System.getProperty(RevizeProperties.WEB_SERVER_NAME);
					revizeServerPort = System.getProperty(RevizeProperties.WEB_SERVER_PORT);
					revizeServer = revizeServerProtocol + "://" + revizeServerName;
					if (revizeServerPort.equals("80") == false) revizeServer += ":" + revizeServerPort;
					if (revizeServer.endsWith("/"))
						revizeServer = revizeServer.substring(0,revizeServer.length()-1);
					if((absoluteurl.endsWith(".html") || absoluteurl.endsWith(".htm")
					|| absoluteurl.endsWith(".jsp") || absoluteurl.endsWith(".asp")
					||absoluteurl.endsWith(".aspx") || absoluteurl.endsWith(".php")) && absoluteurl.indexOf(revizeServer) >= 0 )
					{
						int idx1= my_revizechannelurl.lastIndexOf("/");
						if (idx1 >= 0)
						{
							absoluteurl = absoluteurl.substring(idx1+1);
							absoluteurl = "../"+url;
						}

						isRevizeServerUrl = true;
						/*
						try
						{
							URL thisurl = new URL(new_absoluteurl);
							URLConnection urlConn = thisurl.openConnection();
							urlConn.connect();
							// below line needed to drop connections
							java.io.InputStream stream = urlConn.getInputStream();
						}
						catch(Exception e)
						{
							isValidUrl = false;
						}
						*/
					}
				}
			}

		}
		else if(isPoundInUrl && ti == null) // if it's not a revize managed page
		{
			RevizePage = false;
			//isRevizeServerUrl = true;
			try
			{
				URL thisurl = new URL(absoluteurl);
				URLConnection urlConn = thisurl.openConnection();
				urlConn.connect();
				// below line needed to drop connections
				java.io.InputStream stream = urlConn.getInputStream();
			}
			catch(Exception e)
			{
				isValidUrl = false;
			}
		}
	}

}

%>
<script language="JavaScript" src="/revize/util/snippet_helper.js"></script>
<script language="JavaScript">
/*---------------------------------------------------------------------------
page setup called by onload handler
----------------------------------------------------------------------------*/
function setup()
{	
	//linkmanager_xml.jsp : http://development.revize.com/revize/util/linkmanager_xml.jsp?webspace=ricecountyks&url=index.php&absoluteurl=http%3A//development.revize.com/revize/ricecountyks/editforms/index.php&rte=true&mode=url
	
	var url = <%=StringUtils.convertStringForSource(url)%>;

	//----- Start debugger if RZ.debug true
	if (RZ.debug || parent.mainFrame.RZ.debug)
		debugger

	//----- Display message and possibly quit if trace enabled
	var msg = 'linkmanager_xml.jsp (pausing because trace enabled)\n\n'
	        + 'Continue with mode: <%=mode%> ?'
	if (RZ.trace || parent.mainFrame.RZ.trace)
		if (!confirm(msg)) return	// quit if cancel clicked


	//----- Initialize variables
	var mode = '<%=mode%>';
	var revizeserverurl = '<%=isRevizeServerUrl%>';
	var revizepage = '<%=RevizePage%>';
	var validurl = '<%=isValidUrl%>';
	var absoluteurl = <%=StringUtils.convertStringForSource(absoluteurl)%>;
	var ispoundinurl='<%=isPoundInUrl%>';
	var answer,msg;
	var hashStr = '<%=hashStr%>';
	var other = '<%=other%>';

	RZ.message = '';
	RZmsgAdd( 'mode    ', '\t' + mode )
	RZmsgAdd( 'linkid  ', '\t' + '<%=linkid%>' )
	RZmsgAdd( 'template', '\t' + '<%=template%>' )
	RZmsgAdd( 'module  ', '\t' + '<%=module%>' )
	RZmsgAdd( 'filename', '\t' + '<%=filename%>' )
	RZmsgAdd( 'set     ', '\t' + '<%=set%>' )
	RZmsgAdd( 'url     ', '\t' + escape(url) )

	RZtrace('linkmanager_xml.jsp',RZ.message)
	


	if(mode == 'url')
	{

		//If file link, show the prompt
		if (url.indexOf('.pdf')> 0 || url.indexOf('.doc') > 0 || url.indexOf('.docx') > 0)
		{
			msg = 'BEWARE!! You are linking to a file directly using the "Existing Page" option without using the "File Upload" button.\n\n'
			+ 'This is not a NORMAL procedure, you should check with your Revize administrator to make sure that you are doing it correctly \n\n'
			+ 'Click OK to Continue or Cancel now.'
			answer = confirm(msg);
			if(!answer) return
		}

		if(validurl == 'false')
		{
			msg = 'This specified url was not found.\n\n'
			    + 'Click Ok to continue anyway or\n'
			    + 'Click Cancel to enter another url.'
			answer = confirm(msg);
			if (!answer) return;
		}
		if(revizeserverurl == 'true')
		{
			var revizeip = 'false';
			if(url.indexOf('/revize/') > 0) revizeip='true';
			revizeip = 'false';

			/*
			msg = 'The specified url refers to NON Revize managed page.\n\n'
			    + 'Do not continue if you are typing  the full URL with Revize Server IP or DNS. \n'
			    + 'Please use only relative urls otherwise the link wil not work in the live server.\n\n'
			    + 'Click Ok to accept this URL as entered.'
			*/
			if(revizeip == 'true')
			{
				msg = 'The specified url refers to NON Revize managed page.\n\n'
				+ 'You can not continue if you are typing  the full URL with Revize Server IP or DNS. \n'
				alert(msg);
				return
			}
			else
			{
				msg = 'The specified url refers to NON Revize managed page.\n\n'
				+ 'Non Revize Managed pages will not be editable through Revize CMS. \n'
				+ 'Click OK to accept this URL as entered or Cancel to correct it.'
				answer = confirm(msg);
				if(!answer) return
				revizepage='false';
				//absoluteurl=url;
			}

			/*
			msg = 'The specified url refers to NON Revize managed page.\n\n'
						    + 'Linking to NON Revize managed pages is not allowed.\n'
			alert(msg);
			return;
			*/

		}
		if(ispoundinurl=='true' && '<%=rte%>' == 'true') // if there is pound sign in url
		{

			if(revizepage == 'false')
			{
				parent.mainFrame.listModule = '<%=(m==null)?"":m.getLabel()%>';
				parent.mainFrame.linkProcessRTE('<%=recordid%>',absoluteurl,'<%=templatename%>');
				parent.mainFrame.linkCancel();
				return;

			}
			else
			{
				parent.mainFrame.linkfilename = <%=StringUtils.convertStringForSource(linkfilename)%>
				parent.mainFrame.listModule = '<%=(m==null)?"":m.getLabel()%>';
				parent.mainFrame.linkProcessRTE('<%=recordid%>',url,'<%=templatename%>','<%=hashStr%>')
				parent.mainFrame.linkCancel();
				return;
			}
			//else
//			{
//				parent.mainFrame.RZsetLinkId('-1');
//				parent.mainFrame.newLinkType = 'url';
//				parent.mainFrame.newLinkPage = url;
//				parent.mainFrame.linkProcessListRecord();
//			}


		}
		else if ('<%=rte%>' == 'true' && revizepage == 'true')
		{
			parent.mainFrame.linkfilename = <%=StringUtils.convertStringForSource(linkfilename)%>
			parent.mainFrame.listModule = '<%=(m==null)?"":m.getLabel()%>';
			parent.mainFrame.linkProcessRTE('<%=recordid%>',url,'<%=templatename%>','<%=other%>');
			parent.mainFrame.linkCancel();
			return;
		}
		else if ('<%=rte%>' == 'true' && revizepage == 'false')
		{

			parent.mainFrame.linkfilename = <%=StringUtils.convertStringForSource(linkfilename)%>
			parent.mainFrame.listModule = '<%=(m==null)?"":m.getLabel()%>';
			parent.mainFrame.linkProcessRTE('<%=recordid%>',url,'<%=templatename%>');
			parent.mainFrame.linkCancel();
			return;
		}
		else if ('<%=rte%>' != 'true' && revizepage == 'true')
		{
			//if(ispoundinurl=='true')
			//{
				//parent.mainFrame.linkfilename = '<%=StringUtils.convertStringForSource(linkfilename)%>'+'<%=hashStr%>'
			//	parent.mainFrame.linkfilename = '<%=linkfilename.trim()%>'+'<%=hashStr%>'
			//}
			//else
			//{
				parent.mainFrame.linkfilename = <%=StringUtils.convertStringForSource(linkfilename)%>
			//}
			parent.mainFrame.RZsetLinkId('<%=recordid%>');
			parent.mainFrame.newLinkPage = '<%=templatename%>';
			parent.mainFrame.newLinkType = 'urltemplate';
<%
if (!rz.tracestack.equals(""))	//if any exceptions or errors
{
	%>
			return;	//Java Error Displayed on page
	<%
}
%>
			//parent.mainFrame.XMLForm.linktosectionid.value = '<%= tosectionid %>';
			parent.mainFrame.linkProcessListRecord();

		}
		else
		{

			parent.mainFrame.RZsetLinkId('-1');
			parent.mainFrame.newLinkPage = absoluteurl;
			parent.mainFrame.newLinkType = 'url';
			parent.mainFrame.linkProcessListRecord();
		}
	}
	else if ('<%=fileExists%>' == 'true')
	{
			alert('The file name ('+'<%=filename%>'+') is being used by an existing Revize managed page.'
				     +'\n'
				     +'Please change the file name to something different in the file name box below and then continue.')
			return;

	}
	//----- Display message if file already in use.
	else if ('<%=linkid%>' == '-1')
	{
		var rtn = confirm('The html page already exists:'
		     +'<%=filename%>\n\n'
		     +'Do you want to overwrite.')
		if(rtn==true)
		{
			// NJM - trying to eliminate the use of rightFrame
			//parent.rightFrame.location = '<%=reloadurl%>'+'&overwrite_file=yes';
			document.location = '<%=reloadurl%>'+'&overwrite_file=yes';
			return;
		}
		else
		{
			return;
		}


	}

	//----- If a new link record is created by this jsp, linkmanager_select
	//		must update the newly created record with values so change record
	//		properties from create to update.
	if (mode.indexOf('linkrecord') != -1)
	{
		parent.mainFrame.RZ.record.id = '<%=linkid%>'
		parent.mainFrame.RZ.record.version = '1'
		parent.mainFrame.RZ.record.action = 'update'

		parent.mainFrame.RZ.editrecordid = '<%=linkid%>'
		parent.mainFrame.RZ.editversion = '1'
		parent.mainFrame.RZ.editnextversion = '2'
		parent.mainFrame.RZ.editpriorversion = '1'
		parent.mainFrame.RZ.editaction = 'update'
		parent.mainFrame.RZ.editcurrentcopystatus = '1'	//non working copy
	}

	//----- Once the link record is created, we are done.
	if (mode.indexOf('link') != -1)
	{
		//----- Save link and url if dependent and link module are the same
		if (mode.indexOf('template') == -1)
		{
			parent.mainFrame.RZsetLinkId('<%=linkid%>')
			parent.mainFrame.RZsetUrl(url)
		}
		parent.mainFrame.linkProcessListRecord()
	}
	//----- When mode=templaterecord, the dependent template module is not the
	//		same as the link (or list) module.  In this case, linkmanager_xmldome
	//		is called to update "set" values in the dependent record if they exist.
	//		Publishing will occur so it should not be called unless necessary.
	//
	//		linkmanager_xmldone.jsp returns to this jsp with mode='linkdone' via a
	//		forwardUrl used by a RZsaverecord() request which stores the set values.
	else if (mode.indexOf('templaterecord') != -1)
	{
		parent.mainFrame.RZsetLinkId('<%=linkid%>')
		parent.mainFrame.RZsetUrl(url)
		if (mode == 'templaterecordonly')
		{
			parent.mainFrame.linkProcessListRecord()	//existing link record
			return
		}

		if ('<%=rte%>' == 'true')
			mode += '-linkrecord'		//must still create link record
		else
			mode = 'linkdone'

		//----- Look for set on dependent module
		var set = ''
		var setValue = RZ.parent.mainFrame.document.controlForm.set.value
		var setPairs = setValue.split(',')
		for (var i=0; i<setPairs.length; i++)
		{
			var setModule = RZsubstring(setPairs[i],0,setPairs[i].indexOf("."))
			if( '<%=module%>' == setModule )
				set += setPairs[i] + ','
		}
		set = RZsubstring(set,0,set.length-1)	//strip trailing
		RZtrace('set='+set,setValue)

		RZ.message = '';
		RZ.parameters = '';
		RZaddUrlParameter( 'mode=' + mode )
		RZaddUrlParameter( 'webspace=<%=webspace%>' )

		//----- If there are set values for dependent module record,
		//		call linkmanager_xmldone to store them.
		if (set != '')
		{
			RZaddUrlParameter( 'module=<%=module%>' )
			RZaddUrlParameter( 'recordid=<%=linkid%>' )
			RZaddUrlParameter( 'set=' + escape(set) )
			RZtrace('Calling linkmanager_xmldone.jsp',RZ.message)
			document.location.replace('linkmanager_xmldone.jsp' + RZ.parameters);
		}
		else	//otherwise return to linkmanager_select or call this page again
		{
			if ('<%=rte%>' != 'true')	//if not RTE call, return
				parent.mainFrame.linkProcessListRecord()
			else						//otherwise call this page again
			{
				RZaddUrlParameter( 'module=' + parent.mainFrame.listModule )
				RZtrace('Calling linkmanager_xml.jsp',RZ.message)
				document.location.replace('linkmanager_xml.jsp' + RZ.parameters);
			}
		}
	}
}
</script>
</head>

<body bgcolor="#FFFFFF" text="#000000" onLoad="setup();" leftmargin="0">
</body>
<pre>
<%= rz.tracestack %>
</pre>
</html>
